/* 
 * SaladoPlayer, PTGui and Deep Zoom support for SmugMug
 * Copyright Nicholas Sherlock / Sherlock Photography 2012. http://www.sherlockphotography.org/
 */

//Replace this line if you're hosting the plugin on your own server:
var resources_location = "http://s3.sherlockphotography.org/smugmug/panorama/v1/";

var current_panorama_displayed = false;

function panorama_show_ptgui(settings, target) {
	
	var imageUrls = new Array(15), flashImageUrls = new Array(15);
	var imagesRemain = 15;
	var pageSize = 100;
	var pageStart = 1;
	
	var collect_urls = {
		success : function(o) {
			if (!o.responseXML)
				return false;
			
			var root = o.responseXML.documentElement;
			
			var photos = root.getElementsByTagName('item');
			
			for (var i = 0; i < photos.length; i++) {
				var photo = photos[i];
				
				var caption = photo.getElementsByTagName('title')[0].firstChild.nodeValue;
				
				if (caption.indexOf(settings.pano) == 0) {
					var imageIndex = caption.match(/0?(\d+)$/)[1];
					var imageSizes;
					
					if (photo.getElementsByTagName('group')[0] != undefined) {
						imageSizes = photo.getElementsByTagName('group')[0].getElementsByTagName('content');
					} else {
						imageSizes = photo.getElementsByTagName('media:group')[0].getElementsByTagName('media:content');
					}
					
					//Assume last size is the Original size version
					var size = imageSizes[imageSizes.length - 1];

					if (imageUrls[imageIndex] == undefined) {
						imagesRemain--;
						//We need to load the photos from a domain which has a Flash security policy available:
						flashImageUrls[imageIndex] = size.attributes.getNamedItem('url').value.replace(/^http:\/\/[^\/]+\/(.+)$/, 'http://api.smugmug.com/$1');
						imageUrls[imageIndex] = size.attributes.getNamedItem('url').value;
					}
				}
			}

			if (imagesRemain > 0) {
				if (photos.length < pageSize) {
					return false; //The photos we need aren't in the gallery
				} else {
					//There are more pages to read
					pageStart += pageSize;
					var sUrl = "/hack/feed.mg?Type=gallery&Data=" + settings.gallery + "&format=rss200&ImageCount=100&PageCount=" + pageSize + "&start=" + pageStart;
					
					YAHOO.util.Connect.asyncRequest('GET', sUrl, this, null);
				}
			} else {
				target.innerHTML = '';
				
				YD.setStyle(target, 'width', "100%"); 
				YD.setStyle(target, 'height', "100%");				
				
				var viewer=new PTGuiViewer();
	
				viewer.setSwfUrl(resources_location + "ptgui/viewer.swf");
				viewer.preferFlashViewer();
				settings.htmlPano = imageUrls;
				settings.pano = flashImageUrls;
				viewer.setVars(settings);
	
				viewer.embed(target.id);
			}
		},
		failure : function(o) {
			return false;
		}
	};

	var sUrl = "/hack/feed.mg?Type=gallery&Data="+settings.gallery+"&format=rss200&ImageCount=100&PageCount=" + pageSize + "&start=" + pageStart;
	
	YAHOO.util.Connect.asyncRequest('GET', sUrl, collect_urls, null);
}

function panorama_show_seadragon(settings, target) {
	
	var imageUrls = {};
	var pageSize = 100;
	var pageStart = 1;
	var outstandingRequests = 0;
	var foundEndOfGallery = false;
	var fetch_next_page;
		
	var collect_urls = {
		success : function(o) {
			outstandingRequests--;
			
			if (!o.responseXML)
				return false;
			
			var root = o.responseXML.documentElement;
			
			var photos = root.getElementsByTagName('item');
			
			for (var i = 0; i < photos.length; i++) {
				var photo = photos[i];
				
				var caption = photo.getElementsByTagName('title')[0].firstChild.nodeValue;
				
				if (caption.indexOf(settings.pano) == 0) {
					
					var imageSizes;
					
					if (photo.getElementsByTagName('group')[0] != undefined) {
						imageSizes = photo.getElementsByTagName('group')[0].getElementsByTagName('content');
					} else {
						imageSizes = photo.getElementsByTagName('media:group')[0].getElementsByTagName('media:content');
					}
					
					//Assume last size is the Original size version
					var size = imageSizes[imageSizes.length - 1];

					//Remove the pan name from the start of the image name
					caption = caption.substr(settings.pano.length);
					
					imageUrls[caption] = size.attributes.getNamedItem('url').value.replace(/^http:\/\/[^\/]+\/(.+)$/, 'http://api.smugmug.com/$1');
				}
			}
			
			if (photos.length < pageSize) {
				foundEndOfGallery = true;
			}

			if (outstandingRequests == 0) {
				if (!foundEndOfGallery) {
					fetch_next_page();
					fetch_next_page();
				} else {
					//We read an incomplete page (end of gallery), and all outstanding requests are done, show the viewer! 
					target.innerHTML = '';
					
					YD.setStyle(target, 'width', "100%");
					YD.setStyle(target, 'height', "100%");
					
					//Don't zoom in past 100%
					Seadragon.Config.maxZoomPixelRatio = 1;
					//Don't zoom out past perfectly fitting the image in the window
					Seadragon.Config.minZoomImageRatio = 1;
					Seadragon.Config.imagePath = resources_location + 'seadragon/';
					
					var viewer = new Seadragon.Viewer(target.id);
					
					settings.url = 'dummy';
					
					var tileSource = Seadragon.DziTileSource.createFromJson(settings);
					
					tileSource.getTileUrl = function(level, x, y) {
						var url = imageUrls[level + "_" + x + "_" + y];
						
						if (url)
							return url;
						else
							return imageUrls[Object.keys(imageUrls)[0]];
					};
					
					tileSource.tileExists = function(level, x, y) {
						return imageUrls[level + "_" + x + "_" + y] ? true : false;
					};
					
					viewer.openTileSource(tileSource);
				}
			}
		},
		failure : function(o) {
			outstandingRequests--;
			return false;
		}
	};	
	
	fetch_next_page = function() {
		outstandingRequests++;
		
		var sUrl = "/hack/feed.mg?Type=gallery&Data="+settings.gallery+"&format=rss200&ImageCount=100&PageCount=" + pageSize + "&start=" + pageStart;
		pageStart += pageSize;
		YAHOO.util.Connect.asyncRequest('GET', sUrl, collect_urls, null);
	};
	
	//Fetch in parallel to reduce loading time
	for (var i = 0; i < 4; i++) {
		fetch_next_page();
	}
}

function panorama_show_saladoplayer(settings, target) {
	
	var imageUrls = {};
	var pageSize = 100;
	var pageStart = 1;
	var outstandingRequests = 0;
	var foundEndOfGallery = false;
	var fetch_next_page;
	
	function makesuboptions(options) {
		var result = "";
		var addComma = false;
		
		for ( var option in options) {
			if (addComma)
				result += ",";
			else
				addComma = true;
			
			result += option + ":" + options[option];
		}
		
		return result;
	}	
	
	var collect_urls = {
		success : function(o) {
			outstandingRequests--;
			
			if (!o.responseXML)
				return false;
			
			var root = o.responseXML.documentElement;
			
			var photos = root.getElementsByTagName('item');
			
			for (var i = 0; i < photos.length; i++) {
				var photo = photos[i];
				
				var caption = photo.getElementsByTagName('title')[0].firstChild.nodeValue;
				
				if (caption.indexOf(settings.pano) == 0) {
					
					var imageSizes;
					
					if (photo.getElementsByTagName('group')[0] != undefined) {
						imageSizes = photo.getElementsByTagName('group')[0].getElementsByTagName('content');
					} else {
						imageSizes = photo.getElementsByTagName('media:group')[0].getElementsByTagName('media:content');
					}
					
					//Assume last size is the Original size version
					var size = imageSizes[imageSizes.length - 1];

					//Remove the pan name from the start of the image name
					caption = caption.substr(settings.pano.length) + ".jpg";
					
					imageUrls[caption] = size.attributes.getNamedItem('url').value.replace(/^http:\/\/[^\/]+\/(.+)$/, 'http://api.smugmug.com/$1');
				}
			}
			
			if (photos.length < pageSize) {
				foundEndOfGallery = true;
			}

			if (outstandingRequests == 0) {
				if (!foundEndOfGallery) {
					fetch_next_page();
					fetch_next_page();
				} else {
					var flashvars = {};
					
					target.innerHTML = '';
					
					/* Convert options from PTGui-style/Seadragon style to PanoSalado style */
					var camera_options = {}, autorotation_options = {};
					
					if (!(settings.minpan == -180 && settings.maxpan == 180)) {
						if (settings.minpan !== undefined)
							camera_options['minHorizontalFov'] = settings.minpan;
						if (settings.maxpan !== undefined)
							camera_options['maxHorizontalFov'] = settings.maxpan;
					}
					if (settings.mintilt !== undefined)
						camera_options['minVerticalFov'] = settings.mintilt;
					if (settings.maxtilt !== undefined)
						camera_options['maxVerticalFov'] = settings.maxtilt;
	
					if (settings.pan !== undefined)
						camera_options['pan'] = settings.pan;
					if (settings.tilt !== undefined)
						camera_options['tilt'] = settings.tilt;
					if (settings.fov !== undefined)
						camera_options['fov'] = settings.fov;
					if (settings.minfov !== undefined)
						camera_options['minFov'] = settings.minfov;
					if (settings.maxfov !== undefined)
						camera_options['maxFov'] = settings.maxfov;
					
					if (settings.autorotatedelay !== undefined)
						autorotation_options['delay'] = settings.autorotatedelay;
					if (settings.autorotatespeed !== undefined)
						if (settings.autorotatespeed == 0)
							autorotation_options['enabled'] = false;
						else
							autorotation_options['speed'] = settings.autorotatespeed;
									
					var saladoConfig = "<SaladoPlayer>";
					
					saladoConfig += "<global debug='false'>";
					
					saladoConfig += "<control ";
					
					if (autorotation_options)
						saladoConfig +="autorotation='" + makesuboptions(autorotation_options) +"' ";
					
					if (settings.mouseDrag || settings.mousedrag)
						saladoConfig +="mouseDrag='enabled:true' mouseInertial='enabled:false' ";
					else
						saladoConfig +="mouseDrag='enabled:false' mouseInertial='enabled:true' ";
					
					saladoConfig += " mouseWheelTrap='false' />";

					saladoConfig += "</global>";

					saladoConfig += "<panoramas>";
					
					saladoConfig += "<panorama id='' tiles='tileSize:" + settings.tileSize + ",overlap:" + settings.tileOverlap 
						+ ",width:" + settings.width + ",height:" + settings.height + "' images='";
					
					var addComma = false;
					
					for (var imageName in imageUrls) {
						if (addComma)
							saladoConfig += ",";
						else
							addComma = true;
						
						saladoConfig += imageName +":[" + imageUrls[imageName] + "]";
					}
					
					saladoConfig += "' ";
									
					if (camera_options) {
						saladoConfig += "camera='" + makesuboptions(camera_options) + "' ";
					}
						
					saladoConfig += "/>";
					
					saladoConfig += "</panoramas>";
				
					saladoConfig += 
						'<modules>';

					if (settings.buttons == undefined) {
						settings.buttons = ["out", "in", "fullscreen"] ;
					}

					if (settings.buttons instanceof Array && settings.buttons.length) {
						saladoConfig +=
							'<ButtonBar path="~/buttonbar/ButtonBar-1.3.swf">'+
							'	<buttons path="~/buttonbar/images/buttons_dark_30x30.png">';
						
						for (var index in settings.buttons) {
							saladoConfig +=
							'		<button name="' + settings.buttons[index] + '"/>';
						}
						
						saladoConfig +=
							'	</buttons>'+
							'</ButtonBar>';
					}

					if (settings.mouseDrag || settings.mousedrag) {
						saladoConfig += 
								'<MouseCursor path="~/mousecursor/MouseCursor-1.2.swf">'+
								'	<settings path="~/mousecursor/images/cursors_21x21.png"/>'+
								'</MouseCursor>';
					}
					
					saladoConfig +=
						'</modules>';
					
					saladoConfig += "</SaladoPlayer>";
				
					flashvars.saladoConfig = saladoConfig;
					flashvars.tilde = resources_location + "salado/modules";
					
					var params = {};
					params.play = "true";
					params.loop = "false";
					params.menu = "false";
					params.quality = "high";
					params.scale = "showall";
					params.wmode = "window";
					params.bgcolor = "#000000";
					params.devicefont = "false";
					params.allowfullscreen = "true";
					params.allowScriptAccess = "always";
					swfobject.embedSWF(resources_location + "salado/player.swf", target.id,
								"100%", "100%", "10.1.0", "/ria/expressinstall.swf", flashvars, params);
				}			
			}
		},
		failure : function(o) {
			outstandingRequests--;
			return false;
		}
	};	
	
	fetch_next_page = function() {
		outstandingRequests++;
		
		var sUrl = "/hack/feed.mg?Type=gallery&Data="+settings.gallery+"&format=rss200&ImageCount=100&PageCount=" + pageSize + "&start=" + pageStart;
		pageStart += pageSize;
		YAHOO.util.Connect.asyncRequest('GET', sUrl, collect_urls, null);
	};
	
	//Fetch in parallel to reduce loading time
	for (var i = 0; i < 4; i++) {
		fetch_next_page();
	}
}

function panorama_resize() {
	var panoramaContainer = document.getElementById("panoramaContainer");
	
	if (panoramaContainer) {
		var width = YD.getViewportWidth() - 40 - (lightBoxShowDetails ? 325 : 0);
		
		var height = 
			YD.getViewportHeight() 
			- YAHOO.util.Region.getRegion(document.getElementById('lightBoxMain')).top
			- YAHOO.util.Region.getRegion(document.getElementById('lightBoxCaption')).height
			- 20;
				
		YD.setStyle(panoramaContainer, 'width', width + "px"); 
		YD.setStyle(panoramaContainer, 'height', height + "px");
	}
}

function panorama_hide() {
	if (current_panorama_displayed) {
		YD.setStyle(document.documentElement, 'overflow', 'visible');
		removeFromDOM('panoramaContainer');
		current_panorama_displayed = false;
	}
}

/* Pull a JS object representing the panorama out of a user caption, or null if this
 * fails */
function panorama_extract_descriptor(caption) {
	if (caption) {
		try {
			matches = caption.match(/<span\s+class\s*=\s*['"]my-panorama['"]\s*title\s*=\s*['"]([\s\S]+?)['"]\s*>\s*<\/span>/im);
			 
			if (matches) {
				return eval('(' + matches[1].replace(/<br \/>/g,"").replace(/br \/\n/g, "").replace(/&lt;/g, "<").replace(/&gt;/g, ">").replace(/&apos;/g, "'") + ')');
			}
		} catch (x) {
			//Any failure to extract is the same as having no descriptor.
		}
	}
	
	return null;
}

YE.onDOMReady(function() {
	if (typeof prepLBimg === 'undefined')
		return;

	YE.addListener(window, 'resize', panorama_resize);
	
	var originalPrepLBimg = prepLBimg;
	var originalCloseLightBox = closeLightBox;
	var originalFadeInPhoto = fadeInPhoto;
	
	prepLBimg = function(response) {
		try {
			var lbInfo = YAHOO.lang.JSON.parse(response);
		} catch (x) {
			return;
		}
		
		var panorama_settings;
		
		if (panorama_settings = panorama_extract_descriptor(lbInfo.caption)) {
			try {
				//Merge in the user's global settings if provided
				panorama_settings = YAHOO.lang.merge(typeof panorama_global_settings !== 'undefined' ? panorama_global_settings : {}, panorama_settings);

				//Get SmugMug to set up the page as if it was a movie clip...
				lbInfo.isMovie = true;
				
				//Remove the sizes bar
				if (lbInfo.Nav.indexOf("|") != -1)
					lbInfo.Nav = lbInfo.Nav.substr(lbInfo.Nav.indexOf("|") + 1);
				
				if (panorama_settings.format == 'deepzoom' && !lbInfo.caption.match(/class\s*=\s*['"]microsoftplug/i)) {
					//This is required by Microsoft's seadragon licensing agreement
					lbInfo.caption += "<div class='microsoftplug' style='margin-top:5px; font-size:80%'>Built on Microsoft technology</div>";
				}
				
				//Now call SmugMug's original handling
				var result = originalPrepLBimg(YAHOO.lang.JSON.stringify(lbInfo));

				//aaaand kill the video
				removeFromDOM('smugMovieDiv');

				YD.setStyle(document.documentElement, 'overflow', 'hidden');
				
				var new_panorama = panorama_settings.gallery + ":" + panorama_settings.pano;

				//SmugMug needs to see this to be able to close the LB:
				var dummy = document.getElementById("lightBoxImage");

				if (!dummy) {
					dummy = document.createElement('div');
					dummy.setAttribute('id', 'lightBoxImage');
					
					document.getElementById("lightBoxPhoto").appendChild(dummy);
				}
				
				YD.setStyle(dummy, 'display', 'none');					

				var panoramaContainer = document.getElementById("panoramaContainer");
				
				if (!panoramaContainer) {
					panoramaContainer = document.createElement('div');
					panoramaContainer.setAttribute('id', 'panoramaContainer');
					
					document.getElementById("lightBoxPhoto").appendChild(panoramaContainer);
				}
				
				YD.setStyle(panoramaContainer, 'margin-left', 'auto'); 
				YD.setStyle(panoramaContainer, 'margin-right', 'auto');
				
				//Display panorama at the same size as the image would have been
				/*var width = lbInfo.newWidth;
				var height = lbInfo.newHeight;*/
				
				panorama_resize();
				
				if (new_panorama != current_panorama_displayed) {
					//Remove any pre-existing div...
					removeFromDOM('panoramaDiv');
					
					var panoramaDiv = document.createElement('div');
					panoramaDiv.setAttribute('id', 'panoramaDiv');
					
					panoramaContainer.appendChild(panoramaDiv);
				
					if (panorama_settings.format == 'deepzoomcubic')
						panorama_show_saladoplayer(panorama_settings, panoramaDiv);
					else if (panorama_settings.format == 'deepzoom')
						panorama_show_seadragon(panorama_settings, panoramaDiv);
					else
						panorama_show_ptgui(panorama_settings, panoramaDiv);

					current_panorama_displayed = new_panorama;

					return result;
				} else {
					//Same panorama as last time, so just resize the existing panorama div

					return true;
				}
			} catch (x) {
			}
		} 
		
		//We're not showing a panorama, so remove it if it's there.
		panorama_hide();
		
		return originalPrepLBimg(response);
	};
	
	closeLightBox = function(e) {
		var result = originalCloseLightBox(e);
		
		panorama_hide();
		
		return result;
	};
	
	fadeInPhoto = function() {
		var result = originalFadeInPhoto();
		var settings  = panorama_extract_descriptor(photoInfo[ImageID].caption);
		
		if (settings) {
			//Merge in the user's global settings if provided
			settings = YAHOO.lang.merge(typeof panorama_global_settings !== 'undefined' ? panorama_global_settings : {}, settings);

			if (settings.viewbutton) {
				if (settings.viewbutton === true) {
					settings.viewbutton = resources_location + "viewbutton.png";
					settings.viewbutton_width = 361;
					settings.viewbutton_height = 74;
				}
				
				var target = YD.get('mainImageLink');
	
				var clickToViewPan =  document.createElement('img');
				
				YD.setStyle(clickToViewPan, 'position', 'absolute');
				YD.setStyle(clickToViewPan, 'left', '50%');
				YD.setStyle(clickToViewPan, 'top', '50%');
				YD.setStyle(clickToViewPan, 'margin-left', '-' + Math.round(settings.viewbutton_width / 2) + 'px');
				YD.setStyle(clickToViewPan, 'margin-top', '-' + Math.round(settings.viewbutton_height / 2) + 'px');
				
				clickToViewPan.src = settings.viewbutton;
				
				target.appendChild(clickToViewPan);
			}
		}
		
		return result;
	};
});
